/* (C) 1997 Duddie / Vision Thing Software Group */



#include <stdio.h>
#include "globals.h"
#include "psxhead.h"

int loadRom(char *name)
{
 FILE *tmpFile;
 char tmpstr[256];
 sprintf(tmpstr,"bios\\%s",name);
 
 if (tmpFile = fopen(tmpstr,"rb"))
  {
  fprintf(logfile, "Loading ROM Image %s\n",name);
  fread(psxR, 512*1024,1,tmpFile);
  fclose(tmpFile);
  fprintf(logfile, "ROM Image: %s LOADED\n",name);
  return TRUE;
  }
 else
  {
  fprintf(logfile, "Cannot find ROM Image %s\n",name);
  return FALSE;
  }
}



void resetPS(void)
{
 long i;
 for(i=0;i<=31;i++) reg[i] = regCOP0[i]= 0;
 regHI=regLO=0;
 for(i=0;i<2*1024*1024;i++) psxM[i]=0;
 for(i=0;i<64*1024;i++) psxH[i]=0;
 rPC=0xbfc00000;
}
