
#define TwoMeg 2*1024*1024
#define HalfMeg 512*1024
#define HardSpace 64*1024



EXE_HEADER tmpHead;

FILE *logfile;
FILE *logHfile;

void *tempptr; 


unsigned long *psxML;
unsigned long *psxVL;
unsigned long *psxHL;
unsigned char psxM[2*1024*1024];
unsigned char psxH[64*1024];
unsigned char psxV[512*1024];

int i,j,k;

unsigned long breakpoints[10];

unsigned int op;
unsigned long buf;
unsigned int rt, rs,rd,sa,func;
unsigned long imed;
unsigned long disCT;
unsigned long compAddr;
unsigned long compData;
signed long compDataS;
signed long compDataS1;
signed long compDataS2;
unsigned char compDataB1;
unsigned char compDataB2;
unsigned long VideoAccess;
unsigned long HardAccess;
double long multRes;

int operationGood;

unsigned int curPos;
char tmpstr[256];

/* *** REGISTERS DEFINED HERE *** */

unsigned long rPC = 0x80000000;
unsigned long reg[32] = {0};
signed long *sreg;

void (*romAF[128])(void) = {
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
        /*10*/          romNI,romNI,romNI,romSETJMP,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
        /*20*/          romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
        /*30*/          romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romPRINTF,
        /*40*/          romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI,romNI,
                        romNI,romNI,romNI,romNI,romNI,romNI,romNI};
                        
void (*romBF[128])(void) = {
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romOPENEVENT,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,
                        romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB,romNIB
                        };                      

void (*romCF[128])(void) = {
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,
                        romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC,romNIC
                        };                      


char *regName[32] = {"zero","at","v0","v1","a0","a1","a2","a3",
                     "t0","t1","t2","t3","t4","t5","t6","t7",
                     "s0","s1","s2","s3","s4","s5","s6","s7",
                     "t8","t9","k0","k1","gp","sp","fp","ra"};

char *nem[64] =
       {"special","regimm","j","jal","beq","bne","blez","bgtz",
        "addi","addiu","slti","sltiu","andi","ori","xori","lui",
        "cop0","cop1","cop2","","beql","bnel","blezl","bgtzl",
        "daddi","daddiu","ldl","ldr","","","","",
        "lb","lh","lwl","lw","lbu","lhu","lwr","lwu",
        "sb","sh","swl","sw","sdl","sdr","swr","cache",
        "ll","lwc1","lwc2","","lld","ldc1","ldc2","ld",
        "sc","swc1","swc2","","scd","sdc1","sdc2","sd"};

void (*opF[64])(void) = {opSP,opREGIMM,opJ,opJAL,opBEQ,opBNE,opBLEZ,opNI,
                         opADDI,opADDIU,opSLTI,opSLTIU,opANDI,opORI,opNI,opLUI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
                         opNI,opLH,opNI,opLW,opLBU,opLHU,opNI,opNI,
                         opSB,opSH,opNI,opSW,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI};

char *snem[64] =
        {"sll","","srl","sra","sllv","","srlv","srav",
        "jr","jalr","","","syscall","break","","sync",
        "mfhi","mthi","mflo","mtlo","dsllv","","dsrlv","dsrav",
        "mult","multu","div","divu","dmult","dmultu","ddiv","ddivu",
        "add","addu","sub","subu","and","or","xor","nor",
        "","","slt","sltu","dadd","daddu","dsub","dsubu",
        "tge","tgeu","tlt","tltu","teq","","tne","",
        "dsll","","dsrl","dsra","dsll32","","dsrl32","dsra32"};

void (*opFS[64])(void) = {opSLL,opNI,opSRL,opNI,opSLLV,opNI,opSRLV,opNI,
                         opJR,opJALR,opNI,opNI,opSYSCALL,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
                         opADD,opADDU,opSUB,opSUBU,opAND,opOR,opNI,opNI,
                         opNI,opNI,opSLT,opSLTU,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI};

char *rnem[32] =
        {"bltz","bgez","bltzl","bgezl","","","","",
         "tgei","tgeiu","tlti","tltiu","teqi","","tnei","",
         "bltzal","bgezal","bltzall","bgezall","","","","",
         "","","","","","","",""};

void (*opFR[32])(void) = {
                         opBLTZ,opBGEZ,opNI,opNI,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
                         opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI
                        };

int      reg_mode[32] =
       {5,5,5,5,-1,-1,-1,-1,
        5,5,5,5,5,-1,5,-1,
        5,5,5,5,-1,-1,-1,-1,
        -1,-1,-1,-1,-1,-1,-1,-1};

int    nem_mode[64] =
      {0,1,2,2,8,8,5,5,
       4,4,4,4,4,4,4,10,
       0,0,0,-1,4,4,5,5,
       4,4,4,4,-1,-1,-1,-1,
       4,4,4,4,4,4,4,4,
       4,4,4,4,4,4,4,0,
       4,4,4,-1,4,4,4,4,
       4,4,4,-1,4,4,4,4};

int    snem_mode[64] =
        {7,-1,7,7,3,-1,3,3,
         8,8,-1,-1,0,0,-1,0,
         11,12,11,12,3,-1,3,3,
         6,6,6,6,6,6,6,6,
         3,3,3,3,3,3,3,3,
         -1,-1,3,3,3,3,3,3,
         6,6,6,6,6,-1,6,-1,
         7,-1,7,7,7,-1,7,7};


char disline[256];


void main(void)
{
 int mykey;

 tempptr=psxM;
 psxML=tempptr;

 tempptr=psxV;
 psxVL=tempptr;

 tempptr=psxH;
 psxHL=tempptr;

 sreg=reg;

 for (i=0;i<10;i++) breakpoints[i] = 0;

 logfile = fopen("log.txt","w");
 logHfile = fopen("hardlog.txt","w");
 GrSetMode(GR_width_height_color_graphics,800,600,256);
 GrTextXY( 0,0,"PSEmu v0.01 alpha pre-test",GrWhite(),GrBlack());

 fprintf (logfile, "*** LOG FILE ***\n");

 do
 {
  mykey=getxkey();
  if (mykey == 'L' || mykey == 'l')  psxLoad("MENU.EXE");
  if (mykey == 'W' || mykey == 'w')  walk();
  if (mykey == 'G' || mykey == 'g')  go();
  if (mykey == 'B' || mykey == 'b')  toggleBreakpoint();
  if ((mykey == 584) && (curPos > 0)) curPos--;
  if ((mykey == 592) && (curPos < 30)) curPos++;
  printRegs();
  disasm();
  printCursor();
  sprintf(tmpstr, "%d   %c     ",mykey,(char)mykey);
  GrTextXY( 600,0,tmpstr,GrWhite(),GrBlack());
 } while (mykey != 27);
 GrSetMode(GR_default_graphics);
 fclose(logfile);
 fclose(logHfile);
 return;
}

void printRegs(void)
{
 char mytxt[256];
    sprintf(mytxt, "  pc = 0x%08x",rPC);
    GrTextXY( 600,20,mytxt,GrWhite(),GrBlack());

 for(i=0;i<=31;i++)
   {
     for(j=0;j<=9;j++) tmpstr[j]=' ';
    tmpstr[10]=0;
    compAddr = reg[i]-Mbase;
    if (compAddr>0 && compAddr<TwoMeg)
     for(j=0;j<=9;j++)
      {
       if(psxM[compAddr+j]>31 && psxM[compAddr+j]<128) tmpstr[j]=psxM[compAddr+j];
       else tmpstr[j]=' ';
      }     
    
    sprintf(mytxt, "%4s = 0x%08x %s",regName[i],reg[i],tmpstr);
    GrTextXY( 540,40+12*i,mytxt,GrWhite(),GrBlack());
   }
}

void walk(void)
{
 disCT = rPC - Mbase;
 op = (psxM[disCT+3] & 0xfc) >> 2;
 buf = *(psxML+disCT/4);
 imed = buf & 0x0000ffff;
 rt = (buf >> 16) & 0x1f;
 rs = (buf >> 21) & 0x1f;
 operationGood=TRUE;
 opF[op]();
}

void go(void)
{
 VideoAccess = 0;

 while(kbhit()!=0);
 do
 {
  disCT = rPC - Mbase;
  op = (psxM[disCT+3] & 0xfc) >> 2;
  buf = *(psxML+disCT/4);
  imed = buf & 0x0000ffff;
  rt = (buf >> 16) & 0x1f;
  rs = (buf >> 21) & 0x1f;
  psxHL[0x1110/4]=0xfffffff;
  psxHL[0x1814/4]=0xfffffff;
  operationGood=TRUE;
  opF[op]();
  for (i=0;i<10;i++) if (breakpoints[i] == rPC) operationGood = FALSE;
 } while (operationGood && (kbhit()==0));
  sprintf(tmpstr, "VIDEO ACCESSED %d TIMES           ",VideoAccess);
  GrTextXY(40,520,tmpstr,GrWhite(),GrBlack());
  sprintf(tmpstr, "HARDWARE ACCESSED %d TIMES           ",HardAccess);
  GrTextXY(40,540,tmpstr,GrWhite(),GrBlack());
}

void disasm(void)
{
 disCT = rPC - Mbase;
 for(i=0;i<31;i++)
   {
    disasmLine();
    disCT+=4;
    GrTextXY(48,40+12*i,disline,GrWhite(),GrBlack());
   }
}

void printCursor(void)
{
char brp;

 for(i=0;i<31;i++)
   {
    compAddr = rPC + i*4;
    brp = ' ';
    for (j=0;j<10;j++)
     {
      if (breakpoints[j] == compAddr) brp='b';
     }
    if (curPos == i) sprintf(tmpstr,">%c",brp);
    else sprintf(tmpstr," %c",brp);
    GrTextXY(20,40+12*i,tmpstr,GrWhite(),GrBlack());
   }


}

void toggleBreakpoint(void)
{
 compAddr = rPC + curPos*4;
 for (i=0; i<10;i++)
  {
   if (breakpoints[i] == compAddr) 
    {
     breakpoints[i] = 0;
     return;
    }
  }
 for (i=0; i<10;i++)
  {
   if (breakpoints[i] == 0) 
   {
    breakpoints[i] = compAddr;
    return;
   }
  }
  GrTextXY(40,500,"ONLY 10 BREAKPOINTS!!!! SORRY!!!!! :(          ",GrWhite(),GrBlack());
}



void disasmLine()
{
unsigned int op;
unsigned long buf;
unsigned int rt, rs,rd,sa,func;
unsigned long imed;
op = (psxM[disCT+3] & 0xfc) >> 2;
buf = psxML[disCT/4];
imed = buf & 0x0000ffff;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
rd = (buf >> 11) & 0x1f;
sa = (buf >> 6) & 0x1f;
func = buf & 0x3f;

if (!buf)
 sprintf(disline, "%08x %08x nop                         ", disCT+Mbase, buf);
 
else
 switch (nem_mode[op])
  {
   case 2:
        sprintf(disline, "%08x %08x %-5s 0x%08x                    ", disCT+Mbase, buf, nem[op], ((buf & 0x03ffffff )<< 2)|((disCT+Mbase)&0xf0000000));
        break;
   case 5:
        compData = imed;
        if (compData > 0x7fff) compData |=0xffff0000;
        compData =compData << 2;
        compAddr = compData + disCT + Mbase +4;
        sprintf(disline, "%08x %08x %-5s %s,0x%04x               ", disCT+Mbase, buf, nem[op], regName[rs], compAddr);
        break;
   case 4:
        sprintf(disline, "%08x %08x %-5s %s,%s,0x%04x                    ", disCT+Mbase, buf, nem[op], regName[rt], regName[rs], imed);
        break;
   case 8: // *BRANCHES*
        compData = imed;
        if (compData > 0x7fff) compData |=0xffff0000;
        compData =compData << 2;
        compAddr = compData + disCT + Mbase +4;
        sprintf(disline, "%08x %08x %-5s %s,%s,0x%08x                    ", disCT+Mbase, buf, nem[op], regName[rt], regName[rs], compAddr);
        break;
   case 10:
        sprintf(disline, "%08x %08x %-5s %s,0x%04x                    ", disCT+Mbase, buf, nem[op], regName[rt], imed);
        break;
   case 1:
        if (reg_mode[rt]==5)
        {
         compData = imed;
         if (compData > 0x7fff) compData |=0xffff0000;
         compData =compData << 2;
         compAddr = compData + disCT + Mbase +4;
         sprintf(disline, "%08x %08x %-5s %s,0x%08x                    ", disCT+Mbase, buf, rnem[rt],  regName[rs], compAddr);
        }
        else
        {
         sprintf(disline, "%08x %08x %-5s 0x%08x                    ", disCT+Mbase, buf, "DD",buf);
        }
        break;
   case 0:
        switch (snem_mode[func]) 
         {
           case 9:
                sprintf(disline, "%08x %08x %-5s                               ", disCT+Mbase, buf, snem[func]);
                break;
           case 8:
                sprintf(disline, "%08x %08x %-5s %s                              ", disCT+Mbase, buf, snem[func],regName[rs]);
                break;
           case 6:
                sprintf(disline, "%08x %08x %-5s %s,%s                            ", disCT+Mbase, buf, snem[func], regName[rt], regName[rs]);
                break;
           case 7:
                sprintf(disline, "%08x %08x %-5s %s,%s,0x%02x                              ", disCT+Mbase, buf, snem[func], regName[rd], regName[rt], sa);
                break;
           case 3:
                sprintf(disline, "%08x %08x %-5s %s,%s,%s                    ", disCT+Mbase, buf, snem[func], regName[rd], regName[rs], regName[rt]);
                break;
          default:
                sprintf(disline," S %-5s nem_mode: %2d buf: 0x%08x", snem[func], snem_mode[func], buf);
                break;
         }


        break;
   default:
        sprintf(disline," N %-5s nem_mode: %2d buf: 0x%08x",nem[op],nem_mode[op],buf);
        break;
  }


}
int psxLoad(char *name) /* loads exe file into memory */
{
 FILE *tmpFile;

 for(i=0;i<=31;i++) reg[i] = 0;

 if (tmpFile = fopen(name,"rb"))
  {
  printf("Loading %s\n",name);
  fread(&tmpHead,sizeof(EXE_HEADER),1,tmpFile);
  fseek(tmpFile, 0x800, SEEK_SET); 
  fread(psxM+(tmpHead.t_addr-Mbase), tmpHead.t_size,1,tmpFile);
  fclose(tmpFile);
  }
 rPC = tmpHead.pc0;
 reg[28] = tmpHead.gp0;
 reg[29] = tmpHead.s_addr;
 fprintf(logfile,"EXE TYPE : %s\n",tmpHead.id);
 fprintf(logfile,"Data     : %x\n",tmpHead.data);
 fprintf(logfile,"Text     : %x\n",tmpHead.text);
 fprintf(logfile,"T Addr   : %x\n",tmpHead.t_addr);
 fprintf(logfile,"D Addr   : %x\n",tmpHead.d_addr);
 fprintf(logfile,"B Addr   : %x\n",tmpHead.b_addr);
 fprintf(logfile,"S Addr   : %x\n",tmpHead.s_addr);
 fprintf(logfile,"PC       : %x\n",tmpHead.pc0);

}




void opNI(void)
{

op = (psxM[disCT+3] & 0xfc) >> 2;
buf = *(psxML+disCT/4);
imed = buf & 0x0000ffff;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
func = buf & 0x3f;

if (op) 
sprintf(tmpstr, "NOT IMPLEMENTED! %s           ",nem[op]);
else
sprintf(tmpstr, "NOT IMPLEMENTED! spec %s           ",snem[func]);
GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());

operationGood = FALSE;
}



void opSP(void)
{
buf = psxML[disCT/4];
func = buf & 0x3f;
if (buf) opFS[func]();
else rPC+=4;
}

void opREGIMM(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
if (reg_mode[rt]==5) opFR[rt]();
else opNI();
}



void opLUI(void)
{
buf = *(psxML+disCT/4);
rt = (buf >> 16) & 0x1f;
reg[rt]=buf << 16;
rPC+=4;
}





/* COMPUTATIONAL INSTRUCTIONS */

void opADDIU(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
compData = buf & 0x0000ffff;
if (compData > 0x7fff) compData |=0xffff0000;
compData += reg[rs];
reg[rt]=compData;
rPC+=4;
}

void opADDI(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
compData = buf & 0xffff;
if (compData > 0x7fff) compData |=0xffff0000;
reg[rt]=compData + reg[rs];
rPC+=4;
}

void opANDI(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
compData = buf & 0xffff;
reg[rt]=reg[rs] & compData;
rPC+=4;
}

void opSLTI(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
compData = buf & 0xffff;
if (compData > 0x7fff) compData |=0xffff0000;
if (reg[rs] < compData) reg[rt] = 1;
else reg[rt] = 0;
rPC+=4;
}

void opSLTIU(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
compData = buf & 0xffff;
if (reg[rs] < compData) reg[rt] = 1;
else reg[rt] = 0;
rPC+=4;
}


void opSUBU(void)
{
buf = psxML[disCT/4];
rd = (buf >> 11) & 0x1f;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
reg[rd]=reg[rs] - reg[rt];
rPC+=4;
}

void opADDU(void)
{
buf = psxML[disCT/4];
rd = (buf >> 11) & 0x1f;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
reg[rd]=reg[rs] + reg[rt];
rPC+=4;
}

void opOR(void)
{
buf = psxML[disCT/4];
rd = (buf >> 11) & 0x1f;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
reg[rd]=reg[rt] | reg[rs];
rPC+=4;
}

void opADD(void)
{
buf = psxML[disCT/4];
rd = (buf >> 11) & 0x1f;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
reg[rd]=reg[rs] + reg[rt];
rPC+=4;
}

void opSUB(void)
{
buf = psxML[disCT/4];
rd = (buf >> 11) & 0x1f;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
reg[rd]=reg[rs] - reg[rt];
rPC+=4;
}

void opAND(void)
{
buf = psxML[disCT/4];
rd = (buf >> 11) & 0x1f;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
reg[rd]=reg[rs] & reg[rt];
rPC+=4;
}
void opORI(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
compData = buf & 0xffff;
reg[rt]=reg[rs] | compData;
rPC+=4;
}

void opSLTU(void)
{
buf = psxML[disCT/4];
rd = (buf >> 11) & 0x1f;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

if (reg[rs] < reg[rt]) reg[rd]=1;
else reg[rd]=0;
rPC+=4;
}

void opSLT(void)
{
buf = psxML[disCT/4];
rd = (buf >> 11) & 0x1f;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

compDataS1 = reg[rs];
compDataS2 = reg[rt];
if (compDataS1 < compDataS2 ) reg[rd]=1;
else reg[rd]=0;
rPC+=4;
}

void opMULT(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
multRes=reg[rs]*reg[rt];

}


                /* STORE INSTRUCTIONS */

void opSW(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

compData = buf & 0xffff;
if (compData > 0x7fff) compData |=0xffff0000;

compAddr = compData + reg[rs];

if (compAddr>Mbase && compAddr<(Mbase+TwoMeg))
 {
  compAddr-=Mbase;
  psxML[compAddr/4] = reg[rt];
  rPC+=4;
  return;  
 }
else 
if (compAddr>Mbase3 && compAddr<(Mbase3+TwoMeg))
 {
  compAddr-=Mbase3;
  psxML[compAddr/4] = reg[rt];
  rPC+=4;
  return;  
 }
else if (compAddr>Vbase && compAddr<(Vbase+HalfMeg))
 {
  compAddr-=Vbase;
  psxVL[compAddr/4] = reg[rt];
  rPC+=4;
  VideoAccess++;
  return;  
 }
else if (compAddr>Hbase && compAddr<(Hbase+HardSpace))
 {
  compAddr-=Hbase;
  psxHL[compAddr/4] = reg[rt];
  rPC+=4;
  HardAccess++;
  fprintf(logHfile, "0x%08x  STORE  WORD 0x%08x AT 0x%08x\n", rPC,reg[rt],compAddr+Hbase);
  return;  
 }
else
 {
  sprintf(tmpstr, "STORING W OUTTA MEMORY!!! %8x           ",compAddr);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }
}

void opSH(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

compAddr = buf & 0xffff;
if (compAddr > 0x7fff) compAddr |=0xffff0000;
compAddr += reg[rs];

compDataB1 = (reg[rt]>>8)&0xff;
compDataB2 = reg[rt] & 0xff;
if (compAddr>Mbase && compAddr<(Mbase+TwoMeg))
 {
  compAddr-=Mbase;
  psxM[compAddr] = compDataB2;
  psxM[compAddr+1] = compDataB1;
  rPC+=4;
  return;  
 }
else if (compAddr>Vbase && compAddr<(Vbase+HalfMeg))
 {
  compAddr-=Vbase;
  psxV[compAddr] = compDataB2;
  psxV[compAddr+1] = compDataB1;
  rPC+=4;
  VideoAccess++;
  return;  
 }
else if (compAddr>Hbase && compAddr<(Hbase+HardSpace))
 {
  compAddr-=Hbase;
  psxH[compAddr] = compDataB2;
  psxH[compAddr+1] = compDataB1;
  fprintf(logHfile, "0x%08x  STORE HWORD 0x%08x AT 0x%08x\n", rPC,psxHL[compAddr/4],compAddr+Hbase);
  rPC+=4;
  HardAccess++;
  return;  
 }
else
 {
  sprintf(tmpstr, "STORING H OUTTA MEMORY!!! %8x           ",compAddr);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }


}


void opSB(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

compAddr = buf & 0xffff;
if (compAddr > 0x7fff) compAddr |=0xffff0000;
compAddr += reg[rs];

if (compAddr>Mbase && compAddr<(Mbase+TwoMeg))
 {
  compAddr-=Mbase;
  psxM[compAddr] = reg[rt] &0x000000ff;
  rPC+=4;
  return;  
 }
else if (compAddr>Mbase3 && compAddr<(Mbase3+TwoMeg))
 {
  compAddr-=Mbase3;
  psxM[compAddr] = reg[rt] &0x000000ff;
  rPC+=4;
  return;  
 }
/*else if (compAddr>Vbase && compAddr<(Vbase+HalfMeg))
 {
  compAddr-=Vbase;
  psxV[compAddr] = compDataB2;
  psxV[compAddr+1] = compDataB1;
  rPC+=4;
  VideoAccess++;
  return;  
 }*/
else if (compAddr>Hbase && compAddr<(Hbase+HardSpace))
 {
  compAddr-=Hbase;
  psxH[compAddr] = reg[rt] &0x000000ff;
  fprintf(logHfile, "0x%08x  STORE  BYTE 0x%08x AT 0x%08x\n", rPC,psxHL[compAddr/4],compAddr+Hbase);
  rPC+=4;
  HardAccess++;
  return;  
 }
else
 {
  sprintf(tmpstr, "STORING B OUTTA MEMORY!!! %8x           ",compAddr);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }


}



void opLW(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

compData = buf & 0xffff;
if (compData > 0x7fff) compData |=0xffff0000;

compAddr = compData + reg[rs];

if (compAddr>Mbase && compAddr<Mbase+TwoMeg)
 { 
  compAddr-=Mbase;
  reg[rt] = psxML[compAddr/4];
  rPC+=4;
  return;
 }
else if (compAddr>Mbase3 && compAddr<Mbase3+TwoMeg)
 { 
  compAddr-=Mbase3;
  reg[rt] = psxML[compAddr/4];
  rPC+=4;
  return;
 }
else if (compAddr>Hbase && compAddr<Hbase+HardSpace)
 { 
  compAddr-=Hbase;
  reg[rt] = psxHL[compAddr/4];
  rPC+=4;
  fprintf(logHfile, "0x%08x  LOAD   WORD 0x%08x AT 0x%08x\n", rPC,reg[rt],compAddr+Hbase);
  return;
 }
else
 {
  sprintf(tmpstr, "LOADING W OUTTA MEMORY!!! %8x           ",compAddr);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }
}


void opLHU(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

compData = buf & 0xffff;
if (compData > 0x7fff) compData |=0xffff0000;

compAddr = compData + reg[rs];

if ((compAddr<(Mbase +TwoMeg)) && (compAddr > Mbase))
 {
  compAddr-=Mbase;
  reg[rt] = psxML[compAddr/4];
  reg[rt] = (reg[rt] >> 16) &0x0000ffff;
  rPC+=4;
 }
else if ((compAddr<(Hbase + HardSpace)) && (compAddr> Hbase))
 {
  compAddr-=Hbase;
  reg[rt] = psxHL[compAddr/4];
  reg[rt] = (reg[rt] >> 16) &0x0000ffff;
  fprintf(logHfile, "0x%08x  LOAD  HWORD 0x%08x AT 0x%08x\n", rPC,reg[rt],compAddr+Hbase);
  rPC+=4;
  HardAccess++;
 }
else
 {
  sprintf(tmpstr, "LOADING OUTTA MEMORY!!! %8x           ",compAddr);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }
}

void opLH(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

compData = buf & 0xffff;
if (compData > 0x7fff) compData |=0xffff0000;

compAddr = compData + reg[rs];

if ((compAddr<(Mbase +TwoMeg)) && (compAddr > Mbase))
 {
  compAddr-=Mbase;
  compData = psxML[compAddr/4];
  compData = (compData >> 16) &0x0000ffff;
  if (compData > 0x7fff) compData |=0xffff0000;
  reg[rt] = compData;
  rPC+=4;
 }
else if ((compAddr<(Hbase + HardSpace)) && (compAddr> Hbase))
 {
  compAddr-=Hbase;
  compData = psxHL[compAddr/4];
  compData = (compData >> 16) &0x0000ffff;
  if (compData > 0x7fff) compData |=0xffff0000;
  reg[rt] = compData;
  fprintf(logHfile, "0x%08x  LOAD  HWORD 0x%08x AT 0x%08x\n", rPC,reg[rt],compAddr+Hbase);
  rPC+=4;
  HardAccess++;
 }
else
 {
  sprintf(tmpstr, "LOADING OUTTA MEMORY!!! %8x           ",compAddr);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }
}

void opLBU(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

compData = buf & 0xffff;
if (compData > 0x7fff) compData |=0xffff0000;

compAddr = compData + reg[rs];

if ((compAddr<(Mbase +TwoMeg)) && (compAddr > Mbase))
 {
  compAddr-=Mbase;
  reg[rt] = psxM[compAddr];
  reg[rt] &= 0x000000ff;
  rPC+=4;
 }
else if ((compAddr<(Hbase + HardSpace)) && (compAddr> Hbase))
 {
  compAddr-=Hbase;
  reg[rt] = psxH[compAddr];
  reg[rt] &= 0x000000ff;
  fprintf(logHfile, "0x%08x  LOAD   BYTE 0x%08x AT 0x%08x\n", rPC,reg[rt],compAddr+Hbase);
  rPC+=4;
  HardAccess++;
 }
else
 {
  sprintf(tmpstr, "LOADING OUTTA MEMORY!!! %8x           ",compAddr);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }
}



                /* BRANCH INSTRUCTIONS */

void opJ(void)
{
unsigned long newPC;
buf = psxML[disCT/4];

newPC = ((buf & 0x03ffffff )<< 2)|(rPC & 0xf0000000);
if (newPC>(Mbase+TwoMeg) || newPC<Mbase)
 {
  sprintf(tmpstr, "JUMPING OUTTA MEMORY!!! %8x           ",newPC);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }
rPC+=4;
disCT+= 4;
op = (psxM[disCT+3] & 0xfc) >> 2;
opF[op]();
rPC=newPC;
}

void opJR(void)
{
unsigned long newPC;
buf = psxML[disCT/4];
rs = (buf >> 21) & 0x1f;

newPC = reg[rs];

if (newPC>(Mbase+TwoMeg) || newPC<Mbase)
 {
  if (newPC == 0xa0)
  {
   rPC+=4;
   disCT+= 4;
   op = (psxM[disCT+3] & 0xfc) >> 2;
   opF[op]();
   romAF[reg[9]]();
   return;
  }
  else
  if (newPC == 0xb0)
  {
   rPC+=4;
   disCT+= 4;
   op = (psxM[disCT+3] & 0xfc) >> 2;
   opF[op]();
   romBF[reg[9]]();
   return;
  }
  else
  if (newPC == 0xc0)
  {
   rPC+=4;
   disCT+= 4;
   op = (psxM[disCT+3] & 0xfc) >> 2;
   opF[op]();
   romCF[reg[9]]();
   return;
  }
  else
  {
   sprintf(tmpstr, "JUMPING OUTTA MEMORY!!! %8x           ",newPC);
   GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
   operationGood = FALSE;
   return;
  }
 }
rPC+=4;
disCT+= 4;
op = (psxM[disCT+3] & 0xfc) >> 2;
opF[op]();
rPC=newPC;
}

void opJAL(void)
{
unsigned long newPC;
buf = psxML[disCT/4];

newPC = ((buf & 0x03ffffff )<< 2)|(rPC & 0xf0000000);
if (newPC>(Mbase+TwoMeg) || newPC<Mbase)
 {
  sprintf(tmpstr, "JUMPING OUTTA MEMORY!!! %8x           ",newPC);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }
rPC+=4;
disCT+= 4;
op = (psxM[disCT+3] & 0xfc) >> 2;
opF[op]();
reg[31] = rPC;
rPC=newPC;
}

void opJALR(void)
{
unsigned long newPC;
buf = psxML[disCT/4];
rs = (buf >> 21) & 0x1f;

newPC = reg[rs];
if (newPC>(Mbase+TwoMeg) || newPC<Mbase)
{
  if (newPC == 0xa0)
  {
   rPC+=4;
   disCT+= 4;
   op = (psxM[disCT+3] & 0xfc) >> 2;
   opF[op]();
   reg[31]=rPC;
   romAF[reg[9]]();
   return;
  }
  else
  if (newPC == 0xb0)
  {
   rPC+=4;
   disCT+= 4;
   op = (psxM[disCT+3] & 0xfc) >> 2;
   opF[op]();
   reg[31]=rPC;
   romBF[reg[9]]();
   return;
  }
  else
 {
  sprintf(tmpstr, "JUMPING OUTTA MEMORY!!! %8x           ",newPC);
  GrTextXY(40,500,tmpstr,GrWhite(),GrBlack());
  operationGood = FALSE;
  return;
 }
}
rPC+=4;
disCT+= 4;
op = (psxM[disCT+3] & 0xfc) >> 2;
opF[op]();
reg[31] = rPC;
rPC=newPC;
}

void opBNE(void)
{
unsigned long newPC;
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

rPC+=4;

if (reg[rt]!=reg[rs])
 {
 compData = buf & 0xffff;
 if (compData > 0x7fff) compData |=0xffff0000;
 newPC = (compData << 2) + rPC;
 disCT+= 4;
 op = (psxM[disCT+3] & 0xfc) >> 2;
 opF[op]();
 rPC=newPC;
 }
}

void opBEQ(void)
{
unsigned long newPC;
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;

rPC+=4;

if (reg[rt]==reg[rs])
 {
 compData = buf & 0xffff;
 if (compData > 0x7fff) compData |=0xffff0000;
 newPC = (compData << 2) + rPC;
 disCT+= 4;
 op = (psxM[disCT+3] & 0xfc) >> 2;
 opF[op]();
 rPC=newPC;
 }
}

void opBLEZ(void)
{
unsigned long newPC;
buf = psxML[disCT/4];
rs = (buf >> 21) & 0x1f;

sreg=&reg[rs];
rPC+=4;
if (*sreg<=0)
 {
 compData = buf & 0xffff;
 if (compData > 0x7fff) compData |=0xffff0000;
 newPC = (compData << 2) + rPC;
 disCT+= 4;
 op = (psxM[disCT+3] & 0xfc) >> 2;
 opF[op]();
 rPC=newPC;
 }
}

void opBLTZ(void)
{
unsigned long newPC;
buf = psxML[disCT/4];
rs = (buf >> 21) & 0x1f;

sreg=&reg[rs];
rPC+=4;
if (*sreg<0)
 {
 compData = buf & 0xffff;
 if (compData > 0x7fff) compData |=0xffff0000;
 newPC = (compData << 2) + rPC;
 disCT+= 4;
 op = (psxM[disCT+3] & 0xfc) >> 2;
 opF[op]();
 rPC=newPC;
 }
}

void opBGEZ(void)
{
unsigned long newPC;
buf = psxML[disCT/4];
rs = (buf >> 21) & 0x1f;
sreg=&reg[rs];
rPC+=4;
if (*sreg>=0)
 {
 compData = buf & 0xffff;
 if (compData > 0x7fff) compData |=0xffff0000;
 newPC = (compData << 2) + rPC;
 disCT+= 4;
 op = (psxM[disCT+3] & 0xfc) >> 2;
 opF[op]();
 rPC=newPC;
 }
}

/* SPECIAL INSTRUCTIONS */

void opSLLV(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rd = (buf >> 11) & 0x1f;
rs = (buf >> 21) & 0x1f;

reg[rd]=reg[rt] << (reg[rs] & 0x1f);
rPC+=4;
}

void opSRLV(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rd = (buf >> 11) & 0x1f;
rs = (buf >> 21) & 0x1f;

reg[rd]=reg[rt] >> (reg[rs] & 0x1f);
rPC+=4;
}

void opSLL(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rd = (buf >> 11) & 0x1f;
sa = (buf >> 6) & 0x1f;

reg[rd]=reg[rt] << sa;
rPC+=4;
}

void opSRL(void)
{
buf = psxML[disCT/4];
rt = (buf >> 16) & 0x1f;
rd = (buf >> 11) & 0x1f;
sa = (buf >> 6) & 0x1f;

reg[rd]=reg[rt] >> sa;
rPC+=4;
}


void opSYSCALL(void)
{
 fprintf(logfile,"SYSCALL %d\n",reg[4]);
 rPC+=4;
}



/********* ROM FUNCTIONS *******************/


void romNI(void)
{
 fprintf(logfile,"!CALL: A0 0x%02x 0x%08x 0x%08x 0x%08x\n",reg[9],reg[4],reg[5],reg[6]);
 rPC = reg[31];
 reg[2] = 1;
}

void romNIB(void)
{
 fprintf(logfile,"!CALL: B0 0x%02x 0x%08x 0x%08x 0x%08x\n",reg[9],reg[4],reg[5],reg[6]);
 rPC = reg[31];
 reg[2] = 1;
}

void romNIC(void)
{
 fprintf(logfile,"!CALL: C0 0x%02x 0x%08x 0x%08x 0x%08x\n",reg[9],reg[4],reg[5],reg[6]);
 rPC = reg[31];
 reg[2] = 1;
}

void romOPENEVENT(void) /* b0_08*/
{
 fprintf(logfile,"CALL: OPENEVENT \nclass: 0x%08x spec: 0x%08x mode: 0x%08x func: 0x%08x\n",reg[4],reg[5],reg[6],reg[7]);
 reg[2]=1;
 rPC = reg[31];
}

void romPRINTF(void)
{
 fprintf(logfile,"CALL: PRINTF 0x%08x 0x%08x 0x%08x\n",reg[4],reg[5],reg[6]);
 fprintf(logfile, "   %s\n",psxM+(reg[4]-Mbase));
 rPC = reg[31];
}

void romSETJMP(void)
{
 fprintf(logfile,"CALL: SETJMP 0x%08x 0x%08x 0x%08x\n",reg[4],reg[5],reg[6]);
 rPC = reg[31];
 reg[2] = 0;
}
