/* (C)1997 Duddie / Vision Thing Software Group */

/* TOTAL MESS.... CAN NOT TAKE CONTROL OVER THIS */
/* IT STARTED OWN LIFE... DUNNO IF I EVER BE ABLE TO CLEAN THIS CODE */


#include <stdio.h>
#include <grx20.h>
#include "globals.h"
#include "harddefs.h"
#include "cdcmd.h"
#include "cdrom.h"
#include "cdmac.h"
#include "display.h"

typedef unsigned char u_char;
typedef unsigned long u_long;

#define GPU_status	0x1814/4
#define H_Count		0x1110/4
#define IntrMask	0x1074/4
#define IntrReq		0x1070/4

#define H_IntrReq	0x1070

unsigned long hardRegsR[10000];
unsigned long hardRegsW[10000];

long verticalLine;
long instrCountHoriz;
long vsyncCount;

/* CDROM REGISTERS */

u_char cdCtl;
u_char cdStat;
u_char cdParam[8];
u_char cdResult[8];
u_char cdParamC;
u_char cdParamP;
u_char cdResultC;
u_char cdResultP;
u_char cdResultReady;
u_char cdCmd;

u_char cdResultTN[6];
u_char cdResultTD[4];
int cdTrack;
u_char cdSetSector[4];
int cdPlay;
int cdMode;
int cdIrqNextTime = 0;
int cdReset = 0;
int cdV;
unsigned long gpuData[100];
int gpuCommand = 0;
int gpuDataC = 0;
int gpuDataP = 0;
int cdRErr;
int cdReaded;

long i,j,k;
int imageX0, imageY0;
int imageX1, imageY1;
int imageTransfer = 0;
short videoDesc;
unsigned long lastGpuData;
int dispX,dispY,dispW,dispH;
char newColor1, newColor2;
/* DMA2 variables */

unsigned long addrC;			// transfer address
int dma2C; 				// dma2gpu counter
long iS,iD,jS,jD;
int dmaReady;
long dmaWait;

void hardStoreW(unsigned long addrR, unsigned long bufL);
void hardStoreH(unsigned long addrR, unsigned long bufL);


void cdromWrite(long reg);
void cdromRead(long reg);

u_char doBCD(u_char in)
{
 u_char tmp;
 tmp = in/10;
 return ((tmp<<4)+(in-(tmp*10)));
}

u_char getBCD(u_char in)
{
 return (in>>4)*10+(in&0xf);
}

void incSector(void)
{
 cdSetSector[2]++;
 if(cdSetSector[2] == 75)
  {
   cdSetSector[2] = 0;
   cdSetSector[1]++;

  }
 if(cdSetSector[1] == 60)
  {
   cdSetSector[1] = 0;
   cdSetSector[0]++;
  }
}

void cdromRead(long reg)
{
// fprintf(outfile,"!PSE! CD ROM read: %04x : %02x\n", reg, psxH[reg]);
 switch(reg)
  {
   case H_CDio:
    if (cdResultReady)
     {
      cdResultP++;
      if (cdResultP==cdResultC) cdResultReady = 0;
     }
    return;
  }
}

void cdromWrite(long reg)
{
 int i;
// fprintf(outfile,"!PSE! CD ROM write: %04x : %02x\n", reg, psxH[reg]);
 switch(reg)
  {
   case H_CDpar:
    if ((cdReset == 2) && (psxH[reg] == 0x07))
     {
      //fprintf(outfile,"!PSE! FLUSH CD ROM \n");
      cdParamP=0;
      cdParamC=0;
      cdResultReady=0;
      cdReset = 0;
      cdStat = 0;
//      cdIrqNextTime = 0;
      psxH[H_CDctl] = 0;
      return;
     }
    cdReset=0;
    cdParam[cdParamP++] = psxH[reg];
    cdParamC++;
    if (cdParamP>7)
     {
      cdParamP=7;
      cdParamC=7;
     }
    return;
   case H_CDctl:
    if(psxH[reg] == 0)
     {
      cdParamP=0;
      cdParamC=0;
      cdResultReady=0;
      return;
     }
    if((psxH[reg] & 0x01)) cdResultReady = 1;
    if(psxH[reg] == 0x01) cdReset = 1;
    return;

   case H_CDstat:
    if ((psxH[reg] == 0x07) && (cdReset == 1)) cdReset = 2;
    else cdReset = 0;
    if (cdResultReady && ( (psxH[reg] & 0xff)== 7 ) )
    {
     cdResultC=0;
     cdStat = 0;
     return;
    }
    return;

   case H_CDio:
    cdCmd = psxH[reg]; // get command nr
    if (activeLog) fprintf(outfile, "!PSE! Handling CD-ROM command: %d\n", cdCmd);
    switch(cdCmd)
     {
      case CdlPause:
       if (cdIrqNextTime == 1)
        {
         cdV = vsyncCount+2;
         cdIrqNextTime = 2;
        }
      case CdlNop:
      case CdlReset:
      case CdlDemute:
      case CdlSeekL:
      case CdlSeekP:
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x2;
       cdStat = 2;
       cdResultReady=1;
       break;

      case CdlReadN:
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x02;
       cdStat = 2;
       cdResultReady=1;
       cdIrqNextTime = 1;
       cdV=vsyncCount+2;
       cdReaded = 1;
       break;

      case CdlGetTD:
       cdTrack = (cdParam[0]>>4)*10+cdParam[0]&0xf;
       dcdGetTD(cdTrack+1, cdResultTD);
       cdResultP = 0;
       cdResultC = 4;
       cdResult[0] = 0;
       cdResult[1] = doBCD(cdResultTD[1]);
       cdResult[2] = doBCD(cdResultTD[2]);
       cdResult[3] = doBCD(cdResultTD[3]);
       cdStat = 2;
       cdResultReady=1;
       break;

      case CdlSetloc:
       for(i=0;i<3;i++) cdSetSector[i] = btoi(cdParam[i]);
       cdSetSector[3]=0;
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0;
       cdStat = 2;
       cdResultReady=1;
       break;

      case CdlGetTN:
       dcdGetTN(cdResultTN);
       cdResultP = 0;
       cdResultC = 3;
       cdResult[0] = 0;
       cdResult[1] = doBCD(cdResultTN[0]);
       cdResult[2] = doBCD(cdResultTN[1]);
       cdStat = 2;
       cdResultReady=1;
       break;

      case CdlSetmode:
       cdMode = cdParam[0];
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0;
       cdStat = 2;
       cdResultReady=1;
       fprintf(outfile, "!PSE! mode set to: %02x\n", cdMode);
       break;

      case CdlPlay:
       displayCL(0x44);
       dcdPlay(cdSetSector);
       displayCL(0x00);
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x80;
       cdStat = 2;
       cdResultReady=1;
       break;
     }
    hardInterrupt=1;
    psxHL[IntrReq]|=0x4;
    if(activeLog) fprintf(outfile, "!PSE! setting intr\n");
    return;
  }
}

void doGPURead(void)
{
 latchHRead &= 0xffff;
 if ((latchHRead >= H_CDctl) && (latchHRead <= H_CDstat))
  cdromRead(latchHRead & 0xffff);  // pass only pointer in hardspace (byte)
 latchHRead=0;
 return;
}

void doGPUWrite(void)
{
 latchHWrite &= 0xffff;
 if ((latchHWrite >= H_CDctl) && (latchHWrite <= H_CDstat))
  cdromWrite(latchHWrite & 0xffff);  // pass only pointer in hardspace (byte)
 latchHWrite=0;
 return;
}

void doDMA3(void)
{
 u_long addr;
 u_long size;
 u_long pre;
 int i;

 addr = psxHL[HL_DMA3addr];
 size = psxHL[HL_DMA3size];
 size = (size & 0xffff) * 4; // I need size in bytes
 pre = (addr>>28) & 0xf;
 addr = addr & MbaseM;
 if ((pre == 8) || (pre == 0xA) || (pre == 0))
  {
   for (i=0;i<size;i++) psxM[addr++] = transferB[i];
  }
}


void doGPU(void)
{
 int i;
 if(cdResultReady && cdResultC)
  {
   psxH[H_CDctl]|=0x20;
   psxH[H_CDio] = cdResult[cdResultP];
  }
 else psxH[H_CDctl]&=0xdf;
 psxH[H_CDstat] = cdStat;

 if (instrCountHoriz++>801)
  {
   instrCountHoriz=0;
   verticalLine++;
  }
 psxHL[H_Count] = verticalLine;
  
 psxHL[GPU_status] |=0x74000000;
 psxHL[0x1044/4] = 0xffff;
 psxHW[0x1dae/2] = 0x400;

 if (verticalLine<312) return;
 else
  {
   verticalLine=0;
   psxHL[H_Count] = verticalLine;
   if(activeLog) fprintf(outfile, "!PSE! setting intr vsync\n");
   hardInterrupt=1; 	
   psxHL[IntrReq]|=1;
   vsyncCount++;
   if(dmaReady)
    if(dmaWait==vsyncCount)
     {
      psxHL[IntrReq]|=8; // DMA interrupt
      psxHL[HL_DMAMask] = 1 << (dmaReady+24);
      dmaReady=0;
     }
   if(!(cdResultReady && cdResultC))
    {
     if ( (cdIrqNextTime >= 2) && ( vsyncCount >= cdV))
      {
       if(activeLog) fprintf(outfile, "!PSE! finishing read ");
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x0;
       cdStat = 4;
       cdResultReady=1;
       psxHL[IntrReq]|=0x4;
       cdIrqNextTime = 0;
//       if (cdIrqNextTime == 4) cdIrqNextTime = 0;
       cdV = vsyncCount+2;
      }
     if ((cdIrqNextTime == 1)  && (vsyncCount >=cdV))
      {
       fprintf(outfile, "!PSE! Reading track: ");
       for (i=0;i<4;i++) fprintf(outfile, "%d ", cdSetSector[i]);
       fprintf(outfile, "\n");
       displayCL(0xff);
       if(!(cdRErr = dcdReadLong(cdSetSector)))
        fprintf(outfile, "!PSE! Track succesfully read\n");
       else
        fprintf(outfile, "!PSE! Error reading cdrom %d\n",cdRErr);
       displayCL(0x00);
       incSector();
       cdResultP = 0;
       cdResultC = 1;
       cdResult[0] = 0x20;
       cdStat = 1;
       cdResultReady=1;
       psxHL[IntrReq]|=0x4;
       cdIrqNextTime = 1;
       cdV = vsyncCount+1;
       cdReaded = 0;
      }
    }
  }


}

void updateDisplay(void)
{
 if(dispY>=(dispY+dispH) || dispX>=(dispX+dispW)) return;
 for (i=0;i<dispH;i++)
  putline640L(i, i+dispY, dispX, dispW);
}



void executeGPU(void)
{
 long x0,y0,x1,y1;
 int color16;
 switch (gpuCommand)
  {
   case 0x02:
    fprintf(outfile,"!GPU! Handling fill rect\n");
    y0 = (gpuData[1]>>16) & 0xffff;
    x0 = (gpuData[1] & 0xffff);
    y1 = ((gpuData[2]>>16) & 0xffff) + y0;
    x1 = (gpuData[2] & 0xffff) + x0;
    newColor1 = ((((gpuData[0]>>9)&0x7c00) | ((gpuData[0]>>5)&0x3e0)) >> 8)&0xff;
    newColor2 = (((gpuData[0]>>5)&0x3e0) | (gpuData[0]>>2 & 0x1f))&0xff;
    x0*=2;
    x1*=2;
    fprintf(outfile,"!GPU! rectangle y0=%d y1=%d x0=%d x1=%d\n",y0,y1,x0,x1);

    for(i=y0;i<y1;i++)
     {
      for(j=x0;j<x1;)
      {
       psxV[i*2048+j]=newColor1;
       j++;
       psxV[i*2048+j]=newColor2;
       j++;
      }
     }
    updateDisplay();
    break;
   case 0xa0:
    fprintf(outfile,"!GPU! Handling transfer data to VRAM\n");
    imageY0 = (gpuData[1]>>16) & 0xffff;
    imageX0 = (gpuData[1] & 0xffff);
    imageY1 = ((gpuData[2]>>16) & 0xffff);
    imageX1 = (gpuData[2] & 0xffff);
    imageTransfer = 1;
    break;
  }
 gpuDataC=gpuDataP=0;
}


void doGpuData(long gdata)
{
 lastGpuData = gdata;
 fprintf(outfile,"!GPU! DATA: %08x\n",  gdata);
 if(gpuDataC == 0)
  {
   switch((gdata>>24)&0xff)
    {
     case 0x02:
      gpuDataC = 3;
      gpuCommand = 0x02;
      gpuData[0] = gdata;
      gpuDataP = 1;
      return;
  
     case 0xa0:
      gpuDataC = 3;
      gpuCommand = 0xa0;
      gpuData[0] = gdata;
      gpuDataP = 1;
      return;
     case 0xe3:
      fprintf(outfile,"!GPU! Y = %d X = %d\n",(gdata>>10)&0x3fff,gdata&0x3ff);
      dispX = (gdata>>10)&0x3fff;
      dispY = gdata & 0x3ff;
      if(dispY>=511) dispY=0;
      if(dispX>=1023) dispX=0;
      return;
     
     case 0xe4:
      fprintf(outfile,"!GPU! W = %d H = %d\n",(gdata>>10)&0x3fff,gdata&0x3ff);
      dispW = (gdata>>10)&0x3fff;
      dispH = gdata & 0x3ff;
      if(dispH>=511) dispH=480;
      if(dispW>=1023) dispW=640;
      updateDisplay();
      return;
    }
  }
 else    
  {
   if (gpuDataC)
    {
     gpuData[gpuDataP] = gdata;
     gpuDataP++;
     if(gpuDataP == gpuDataC) executeGPU();
    }
   return;
  }
}

void hardStoreW(unsigned long addrR, unsigned long bufL)
{
 
 switch (addrR)
  {

   case H_DMA2addr:
    psxHL[HL_DMA2addr]=bufL;
//    fprintf(outfile,"!DMA! GPU DMA addr = %08x\n",psxHL[HL_DMA2addr]);
    return;

   case H_DMA2size:
    psxHL[HL_DMA2size]=bufL;
    return;

   case H_DMA2ctl:
    fprintf(outfile,"!PSE! GPU DMA addr: %08x, size: %08x ctl: %08x\n",  psxHL[HL_DMA2addr], psxHL[HL_DMA2size], bufL);
    psxHL[HL_DMA2ctl]=bufL;
    psxHL[HL_DMA2ctl]&=0xfeffffff;
    if ((bufL & 0x01000400) == 0x01000400)
     {
      fprintf(outfile,"!DMA! GPU command transfer \n");
      addrC = psxHL[HL_DMA2addr];
      if((((addrC >> 24)&0xff) == 0x80) || (((addrC >> 24)&0xff) == 0xa0) || (((addrC >> 24)&0xff) == 0x00)) addrC &= MbaseM;

// this routine should also handle transfers from ROM and scratch pad if possible

      if (addrC < MbaseS && addrC>0)
       {
        dma2C = ((psxML[addrC/4] >> 24) & 0xff) + 1; // 'coz we are countig from 1
        for (i=1;i<dma2C;i++) doGpuData(psxML[addrC/4+i]);
          fprintf(outfile,"!DMA! command: %08x \n",psxML[addrC/4]);
        
/*        for (i=1;i<dma2C;i++)
          fprintf(outfile,"!DMA! command: %08x \n",psxML[addrC/4+i]);*/
       }
      else
       {
        fprintf(outfile,"!DMA! wrong memory location \n");
       }
      dmaReady = 4;
      dmaWait = vsyncCount+2;
      return;
     }

    if ((bufL & 0x01000200) == 0x01000200)
     {
      addrC = psxHL[HL_DMA2addr];
      if(((addrC >> 24)&0xff) == 0x80) addrC &= MbaseM;
      // this routine should also handle transfers from ROM and scratch pad if possible
      if (addrC < MbaseS && addrC>0)
       {
        if(imageTransfer && imageY1<512 && imageX1<1024)
         {
          fprintf(outfile,"!DMA! transfering X=%d Y=%d W=%d H=%d\n",imageX0,imageY0,imageX1,imageY1);
          iS=imageY0*2048;
          iD=(imageY0+imageY1)*2048;
          jS=imageX0*2;
          jD=(imageX0+imageX1)*2;
          for(i=iS; i<iD; i+=2048) for(j=jS;j<jD;j++) psxV[i+j]=psxM[addrC++];
          updateDisplay();
          imageTransfer=0;
	  dmaReady = 4;
          dmaWait = vsyncCount+2;
          return;
         }
      }
    }
    return;

   case H_DMA3addr:
    psxHL[HL_DMA3addr]=bufL;
    return;

   case H_DMA3size:
    psxHL[HL_DMA3size]=bufL;
    return;

   case H_DMA3ctl:
//    psxHL[HL_DMA3ctl]=bufL;
    if((bufL&0x01000000)==0x01000000)
     {
      fprintf(outfile,"!PSE! CDROM DMA addr: %08x, size: %08x ctl: %08x\n",  psxHL[HL_DMA3addr],psxHL[HL_DMA3size],psxHL[HL_DMA3ctl]);
      doDMA3();
      cdReaded = 1;
//      dmaReady = 3;
//      dmaWait = vsyncCount+2;
     }
    psxHL[HL_DMA3ctl]=bufL & 0xfeffffff;
    return;
   case 0x10e8:
    psxHL[0x10e8/4]=bufL & 0xfeffffff;
    return;

   case H_GPUdata:
    doGpuData(bufL);
    return;
   case H_DMAMask:
    psxHL[HL_DMAMask]&=((~bufL)&0xff000000);
    return;
  }
 psxHL[addrR/4]=bufL;
}

void hardStoreH(unsigned long addrR, unsigned long bufL)
{
 if (addrR == 0x1070)
  {
   psxHW[addrR/2]&=bufL;
   return;
  }
 psxHW[addrR/2]=bufL;
}
